Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.functions
Class FunctionLibraryList

    java.lang.Object
      net.sf.saxon.functions.FunctionLibraryList

All Implemented Interfaces:
  Serializable, FunctionLibrary, XQueryFunctionBinder

    public class FunctionLibraryList

extends Object
implements FunctionLibrary, XQueryFunctionBinder

A FunctionLibraryList is a list of FunctionLibraries. It is also a FunctionLibrary in its own right. When required, it searches the list of FunctionLibraries to find the required function.

See Also:
  Serialized Form

Field Summary
`List<FunctionLibrary>` | `libraryList`

Constructor Summary
`FunctionLibraryList()`

Method Summary
`int` | `addFunctionLibrary(FunctionLibrary lib)` Add a new FunctionLibrary to the list of FunctionLibraries in this FunctionLibraryList.
`Expression` | `bind(StructuredQName functionName, Expression[] staticArgs, StaticContext env, Container container)` Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments.
`FunctionLibrary` | `copy()` This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.
`FunctionLibrary` | `get(int n)` Get the n'th function library in the list
`XQueryFunction` | `getDeclaration(StructuredQName functionName, Expression[] staticArgs)` Get the function declaration corresponding to a given function name and arity
`SequenceType[]` | `getFunctionSignature(StructuredQName functionName, int arity)` Test whether a system function with a given name and arity is available, and return its signature.
`List<FunctionLibrary>` | `getLibraryList()` Get the list of contained FunctionLibraries.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### libraryList

    public List<FunctionLibrary> libraryList

Constructor Detail

### FunctionLibraryList

    public FunctionLibraryList()

Method Detail

### addFunctionLibrary

    public int addFunctionLibrary(FunctionLibrary lib)

  Add a new FunctionLibrary to the list of FunctionLibraries in this FunctionLibraryList. Note that libraries are searched in the order they are added to the list.

  Parameters:
    `lib` - A function library to be added to the list of function libraries to be searched.
  Returns:
    the position of the library in the list

### get

    public FunctionLibrary get(int n)

  Get the n'th function library in the list

### getFunctionSignature

    public SequenceType[] getFunctionSignature(StructuredQName functionName,
                                               int arity)

  Test whether a system function with a given name and arity is available, and return its signature. This supports the function-available() function in XSLT. This method may be called either at compile time or at run time.

  Specified by:
    `getFunctionSignature` in interface `FunctionLibrary`
  Parameters:
    `functionName` - the name of the function
    `arity` - The number of arguments. This is set to -1 in the case of the single-argument function-available() function
  Returns:
    if a function of this name and arity is available for calling, then the type signature of the function, as an array of sequence types in which the zeroth entry represents the return type; otherwise null

### bind

    public Expression bind(StructuredQName functionName,
                           Expression[] staticArgs,
                           StaticContext env,
                           Container container)
                    throws XPathException

  Bind an extension function, given the URI and local parts of the function name, and the list of expressions supplied as arguments. This method is called at compile time.

  Specified by:
    `bind` in interface `FunctionLibrary`
  Parameters:
    `functionName` -
    `staticArgs` - The expressions supplied statically in arguments to the function call. The length of this array represents the arity of the function. The intention is that the static type of the arguments (obtainable via getItemType() and getCardinality() may be used as part of the binding algorithm. In some cases it may be possible for the function to be pre-evaluated at compile time, for example if these expressions are all constant values.
    `env` -
    `container` -
  Returns:
    An object representing the extension function to be called, if one is found; null if no extension function was found matching the required name and arity.
  Throws:
    `XPathException` - if a function is found with the required name and arity, but the implementation of the function cannot be loaded or used; or if an error occurs while searching for the function.

### getDeclaration

    public XQueryFunction getDeclaration(StructuredQName functionName,
                                         Expression[] staticArgs)

  Get the function declaration corresponding to a given function name and arity

  Specified by:
    `getDeclaration` in interface `XQueryFunctionBinder`
  Parameters:
    `functionName` - the name of the function as a QName
    `staticArgs` - the expressions supplied as arguments in the function call (typically, we only need to know the number of arguments)
  Returns:
    the XQueryFunction if there is one, or null if not.

### getLibraryList

    public List<FunctionLibrary> getLibraryList()

  Get the list of contained FunctionLibraries. This method allows the caller to modify the library list, for example by adding a new FunctionLibrary at a chosen position, by removing a library from the list, or by changing the order of libraries in the list. Note that such changes may violate rules in the language specifications, or assumptions made within the product.

  Returns:
    a list whose members are of class FunctionLibrary

### copy

    public FunctionLibrary copy()

  This method creates a copy of a FunctionLibrary: if the original FunctionLibrary allows new functions to be added, then additions to this copy will not affect the original, or vice versa.

  Specified by:
    `copy` in interface `FunctionLibrary`
  Returns:
    a copy of this function library. This must be an instance of the original class.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.